program asmpre;

{$APPTYPE CONSOLE}

uses
  SysUtils;

//#macro <name> -  
//#endmacro -   
//#usemacro <name> <par0>,<par1>,<par2>... -  

const
 MAXMACROS=1000;
 MAXMACROLINES=10000;

 RES_NOTHING=0; // checkline  
 RES_MACROENDED=1; //   #endmacro
 RES_PLAINLINE=2; //  


var
 macrolines:array[0..MAXMACROLINES-1]of string; // ,      '#endmacro'
 macronames:array[0..MAXMACROS-1]of string; //  
 firstmacrolines:array[0..MAXMACROS-1]of integer; //    
 curnmacros:integer; //    macronames,firstmacrolines
 curnmacrolines:integer; //    macrolines
 fin:text;
 fout:text;
 finname,foutname:string;
 readword_s:string; //  readword
 readword_i:integer; //    readword
 nomacro:integer;

procedure readline(var nline:integer;var s:string);
//     
begin
  if nline=nomacro
  then readln(fin,s)
  else begin
    s:=macrolines[nline];
    inc(nline);
  end;
end;

procedure writeline(s:string);
begin
  writeln(fout,s);
end;

function eoffin:boolean;
begin
  eoffin:=eof(fin);
end;


procedure initreadword(s:string;i:integer);
begin
  readword_s:=s;
  readword_i:=i;
end;

procedure readword(var word:string;termchar:char);
var
  c:char;
begin
  word:='';
  while readword_i<=length(readword_s) do
  begin
    c:=readword_s[readword_i];
    inc(readword_i);
    if c=termchar then break;
    word:=word+c;
  end;
end;



function checkline(var s:string):integer;
Forward;

procedure usemacro(firstmacroline:integer;
 par0,par1,par2,par3,par4,par5,par6,par7,par8,par9:string);
//     #endmacro
//  \<>  
var
  wasline:string;
  decodedline:string;
  i:integer;
  macroended:boolean;
  replacing:boolean;
  curmacroline:integer;
begin
//writeline('USEMACRO:'+par0+','+par1+','+par2);
 curmacroline:=firstmacroline;
 while true do
 begin
   readline(curmacroline,wasline); //      (   )
//writeline('USEMACRO:'+wasline);
   //convertline(wasline,decodedline,par0,par1,par2,par3,par4,par5,par6,par7,par8,par9);
   decodedline:='';
   replacing:=false;
   if wasline<>'' then
   for i:=1 to length(wasline) do
   begin // convertline
     if replacing
     then begin
       case wasline[i] of
         '0':decodedline:=decodedline+par0;
         '1':decodedline:=decodedline+par1;
         '2':decodedline:=decodedline+par2;
         '3':decodedline:=decodedline+par3;
         '4':decodedline:=decodedline+par4;
         '5':decodedline:=decodedline+par5;
         '6':decodedline:=decodedline+par6;
         '7':decodedline:=decodedline+par7;
         '8':decodedline:=decodedline+par8;
         '9':decodedline:=decodedline+par9;
         else decodedline:=decodedline+'ERROR';
       end; //case
       replacing:=false;
     end
     else //not replacing
       if wasline[i]='\'
       then replacing:=true
       else decodedline:=decodedline+wasline[i];
   end; // convertline
   // convertline
   macroended:=(checkline(decodedline)=RES_MACROENDED); //  (   -   usemacro)
   if macroended then break;
   //writeline(decodedline);
 end; //while
end;

function checkline(var s:string):integer;
//  (   -  usemacro)
var
  res:integer;
  wasline:string;
  word:string;
  macroname:string;
  firstmacroline:integer;
  i:integer;
  macroended:boolean;
  par0,par1,par2,par3,par4,par5,par6,par7,par8,par9:string;
begin
 res:=RES_NOTHING;
 if s<>''
 then
   if s[1]='#'
   then begin //
     initreadword(s,2);
     readword(word,' ');
     if word='macro'
     then begin // 
       //FIXME   ,       
       readword(macroname,' ');
//writeline('MACRO: macroname='+macroname);
       macronames[curnmacros]:=macroname;
       firstmacrolines[curnmacros]:=curnmacrolines;
       while not eoffin do
       begin //      
         readline(nomacro,wasline); //      (   )
//writeline('MACRO:'+wasline);
         macrolines[curnmacrolines]:=wasline;
         inc(curnmacrolines);
         macroended:=(wasline='#endmacro'); //   !
         if macroended then break;
       end; //      
       inc(curnmacros);
     end // 
     else if word='endmacro'
     then begin
       res:=RES_MACROENDED;
     end
     else if word='usemacro'
     then begin // 
       readword(macroname,' ');
       readword(par0,',');
       readword(par1,',');
       readword(par2,',');
       readword(par3,',');
       readword(par4,',');
       readword(par5,',');
       readword(par6,',');
       readword(par7,',');
       readword(par8,',');
       readword(par9,',');
       //    
       firstmacroline:=-1;
       if curnmacros<>0 then
       for i:=0 to curnmacros do
       begin //    
         if macroname=macronames[i]
         then begin
           firstmacroline:=firstmacrolines[i];
           break;
         end;
       end; //    
       if firstmacroline=-1
       then writeline('NO MACRO '+macroname)
       else usemacro(firstmacroline,par0,par1,par2,par3,par4,par5,par6,par7,par8,par9);
     end; // 
   end //
   else begin // 
     writeline(s); //   ,    
     //res:=RES_PLAINLINE;
   end;
 checkline:=res;
end;

procedure parsefile;
var
  wasline:string;
  plainline:boolean;
begin
 while not eoffin do
 begin
   readline(nomacro,wasline); //      (   )
//writeline('OUT:'+wasline);
   plainline:=(checkline(wasline)=RES_PLAINLINE); //  (   -  usemacro)
   //if plainline then writeline(wasline); //   ,    
 end;
end;

begin
  { TODO -oUser -cConsole Main : Insert code here }
 curnmacros:=0; //    macronames,firstmacrolines
 curnmacrolines:=0; //    macrolines
 nomacro:=-1;
 finname:='fin';
 foutname:='fout';
 if ParamCount > 0
 then begin
   finname:=ParamStr(1);
   if ParamCount > 1
   then foutname:=ParamStr(2);
 end;
 assignfile(fin,finname);
 assignfile(fout,foutname);
 reset(fin);
 rewrite(fout);
 parsefile;
 closefile(fout);
 closefile(fin);
end.
